'$DYNAMIC
'$INCLUDE: 'CONNECT4.BI'

TYPE SocketType
 Handle AS LONG
 State AS INTEGER
 OldState AS INTEGER
 Received AS STRING * 256
 ReceivedBytes AS INTEGER
 ReceivedLine AS STRING * 128
 ReceivedLineBytes AS INTEGER
 send AS STRING * 256
 SendBytes AS INTEGER
END TYPE

DECLARE FUNCTION CheckForWinner ()                        ' Check for winner
DECLARE FUNCTION Interpolate (Number1%, Number2%, Value%, MaxValue%)
DECLARE FUNCTION SafeToPut ()                             ' Safe to drop
DECLARE SUB AlertCheck ()                                 ' Alert check
DECLARE SUB CheckForCollide ()                            ' Check for collide
DECLARE SUB CheckGameStatus ()                            ' Who/what/when
DECLARE SUB ConnectMe (IP.address$)                       ' Connection
DECLARE SUB CustomInput (Text$, Char$, CurPos%, Length%)  ' Text Input
DECLARE SUB DrawGraphics ()                               ' Draw graphics
DECLARE SUB EndLoop ()                                    ' Blit stuff
DECLARE SUB GetInput ()                                   ' Keyboard+Mouse
DECLARE SUB Init ()                                       ' Initiate all
DECLARE SUB MakeBox (x1%, y1%, x2%, y2%)                  ' Make box alert
DECLARE SUB Messaging ()                                  ' Message system
DECLARE SUB MouseInput ()                                 ' Mouse in game
DECLARE SUB Notes ()                                      ' Notes
DECLARE SUB PALfadeBlack (Level%, ColA%, ColB%)           ' Fade black
DECLARE SUB PalLightning ()                               ' Lightning color
DECLARE SUB PALpcr (I%, R%, G%, B%)                       ' Pal Array Get
DECLARE SUB PALpcw (I%, R%, G%, B%)                       ' Pal Array Set
DECLARE SUB PALscr (I%, R%, G%, B%)                       ' Pal Screen Get
DECLARE SUB PALscw (I%, R%, G%, B%)                       ' Pal Screen Set
DECLARE SUB PrintVGA (Text$, x%, Y%, FG%, BG%)            ' Print stuff
DECLARE SUB QuitEntireProgram ()                          ' Close all

DECLARE FUNCTION DSOCKlisten% ()
DECLARE FUNCTION DSOCKPoll% ()
DECLARE FUNCTION GetSockByHandle% (sHandle AS LONG)
DECLARE SUB SockReceiveData (sHandle AS INTEGER)
DECLARE FUNCTION CloseSock% (sHandle AS INTEGER)
DECLARE SUB SockSendData (sHandle AS INTEGER)
DECLARE FUNCTION ConnectTo% (sHandle AS INTEGER, stHostName AS STRING, iPort AS INTEGER)
DECLARE SUB SockPrepare ()
DECLARE FUNCTION SendData (sHandle AS INTEGER, stMessage AS STRING)
DECLARE SUB ProcessData (sHandle AS INTEGER)
DECLARE SUB ProcessRemoteAction (stAction AS STRING)
DECLARE FUNCTION LocalIP% ()
DECLARE SUB AddMessage (stMessage AS STRING, iColor AS INTEGER)
DECLARE FUNCTION GetLocalIP$ ()

COMMON SHARED Sock()  AS SocketType                          ' Socket Handles
COMMON SHARED CR AS STRING * 2

COMMON SHARED InputText$, FADE%                '' Text field and fade
COMMON SHARED FrameTile%, ColTile%             '' Animation cycles
COMMON SHARED Mouse%, MX%, MY%, LB%, MLB1%     '' Mouse input
COMMON SHARED HotSpot%, PHotSpot%              '' Mouse stuff
COMMON SHARED ScrollY%, NumbMess%              '' Scroll messages coor
COMMON SHARED Alert%, AlertStep%, Quit%        '' Alert window
COMMON SHARED CH$, INS%, CTRL%, ALT%           '' Keys used in game

COMMON SHARED REMOTE  '' TEMPORARY MARCADE REMOTE USER

'''''' DATA TO EXCHANGE BETWEEN COMPUTERS:

COMMON SHARED PlayerStatus                     '' What is happening?
COMMON SHARED PlayersTurn                      '' Random choice who goes
COMMON SHARED HandPosSent                      '' Is hand position sent?
COMMON SHARED HandLastSent AS SINGLE

DIM SHARED Sock(0 TO 1) AS SocketType

DIM SHARED GameBoard(13, 12) AS INTEGER        '' Game board
DIM SHARED Messages(-1 TO 16) AS STRING        '' Message
DIM SHARED Player(4, 1)                        '' Players' properties
DIM SHARED PlayerNames(1) AS STRING            '' Players' names
DIM SHARED WinRow(6) AS INTEGER                '' Coordinates of winning row

'''''' END DATA

DIM SHARED BackGFX(10369)                      '' Top.Left Texture GFX
DIM SHARED Board(11521)                        '' Board Top.Right GFX
DIM SHARED BottomBar(1281)                     '' Bottom lightning GFX
DIM SHARED Div4(255)                           '' For motion blur lightning
DIM SHARED EXITbutton(130, 1)                  '' EXIT GFX
DIM SHARED ExtraGFX(130, 2)                    '' Extra graphics GFX
DIM SHARED Hand(1153, 1)                       '' Hand animation GFX
DIM SHARED OKyesNobutton(161, 5)               '' Buttons GFX
DIM SHARED Pal(255, 2)                         '' Palette buffer
DIM SHARED Pieces(130, 7, 1)                   '' Pieces GFX DATA
DIM SHARED SCR(255, 2)                         '' Palette screen
DIM SHARED RightBar(1153)                      '' Right lightning GFX
DIM SHARED ScrollArrows(61, 3)                 '' Scrollbar arrows GFX
DIM SHARED SendButton(161, 1)                  '' SEND Button GFX

'' Init and connect
FADE = 1
PlayersTurn = 0   '' TEMPORARY
HandPosSent = 1   '' Are we waiting for an acknowledgement from remote
		  '' user telling us he received our Hand coordinate?

CR = CHR$(13) + CHR$(10)
Init
REMOTE = PlayersTurn
HandPosSent = 0

'' Main loop
DO
 IF DSOCKPoll% < 0 THEN
  PRINT "[ERROR] Polling sockets wend wrong."
 END IF
 IF Sock(0).State <> 7 THEN
  Alert = 3
 END IF

 GetInput
 IF CH$ = CHR$(0) + CHR$(63) THEN REMOTE = REMOTE XOR 1      '' TEMPORARY
 IF CH$ = CHR$(0) + CHR$(65) THEN Alert = 3                  '' TEMPORARY
 IF Alert = 0 THEN
  CheckGameStatus
  CheckForCollide
  IF Mouse THEN MouseInput
  Messaging
  IF CH$ = CHR$(27) THEN Alert = 1
 END IF
 PalLightning
 DrawGraphics
 AlertCheck
 IF Mouse THEN
 DQBput B0, MX, MY, VARSEG(ExtraGFX(0, 2)), VARPTR(ExtraGFX(0, 2)) ' mouse
 END IF
 EndLoop
LOOP UNTIL Quit

'' Fade out
FOR I = 0 TO 63
PALfadeBlack I, 0, 255
EndLoop
NEXT

'' Close it all
QuitEntireProgram

REM $STATIC
SUB AddMessage (stMessage AS STRING, iColor AS INTEGER)

 FOR I = 0 TO 14
  Messages(I) = Messages(I + 1)
 NEXT I
 Messages(15) = stMessage + CHR$(iColor)
 NumbMess = NumbMess - (NumbMess < 16)
 ScrollY = 0

END SUB

REM $DYNAMIC
SUB AlertCheck

'' Alert steps
IF Alert = 0 THEN AlertStep = AlertStep + (AlertStep > 0)
IF Alert THEN AlertStep = AlertStep - (AlertStep < 44)

IF AlertStep = 44 THEN
 SELECT CASE Alert
  CASE 1
     IF UCASE$(CH$) = "Y" OR CH$ = CHR$(13) THEN Quit = 1
     IF UCASE$(CH$) = "N" OR CH$ = CHR$(27) THEN Alert = 0
     IF MY >= 101 AND MY <= 110 THEN
     SELECT CASE MX
     CASE 112 TO 143: HotSpot = 10
     CASE 152 TO 183: HotSpot = 11
     END SELECT
     END IF
     IF MLB1 = 1 THEN PHotSpot = HotSpot
    MakeBox 60, 85, 259, 114
    PrintVGA "Are you sure you want to quit?", 83, 91, 255, 254
    DQBfPut B0, 112, 101, VARSEG(OKyesNobutton(0, 2)), VARPTR(OKyesNobutton(0, 2))
    DQBfPut B0, 152, 101, VARSEG(OKyesNobutton(0, 4)), VARPTR(OKyesNobutton(0, 4))
      IF PHotSpot = HotSpot THEN
       IF HotSpot = 10 THEN DQBfPut B0, 112, 101, VARSEG(OKyesNobutton(0, 3)), VARPTR(OKyesNobutton(0, 3))
       IF HotSpot = 11 THEN DQBfPut B0, 152, 101, VARSEG(OKyesNobutton(0, 5)), VARPTR(OKyesNobutton(0, 5))
       IF MLB1 = -1 THEN
	IF HotSpot = 10 THEN Quit = 1
	IF HotSpot >= 10 THEN Alert = 0
       END IF
      END IF
  CASE 2
     IF CH$ = CHR$(13) OR CH$ = CHR$(27) THEN
      Alert = 0
      REDIM GameBoard(13, 12) AS INTEGER
      REDIM WinRow(6) AS INTEGER
     END IF
     IF MY >= 101 AND MY <= 110 THEN
     IF MX >= 144 AND MX <= 175 THEN
     HotSpot = 10
     END IF
     END IF
     IF MLB1 = 1 THEN PHotSpot = HotSpot
    MakeBox 100, 85, 219, 114
    a$ = PlayerNames(1 - PlayersTurn) + " WINS!!"
    x = DQBlen(a$)
    PrintVGA a$, 160 - (x \ 2), 92, 255, 254
    DQBfPut B0, 144, 101, VARSEG(OKyesNobutton(0, 0)), VARPTR(OKyesNobutton(0, 0))
    IF PHotSpot = HotSpot THEN
    IF HotSpot = 10 THEN
    DQBfPut B0, 144, 101, VARSEG(OKyesNobutton(0, 1)), VARPTR(OKyesNobutton(0, 1))
    IF MLB1 = -1 THEN Alert = 0: REDIM GameBoard(13, 12) AS INTEGER: REDIM WinRow(6) AS INTEGER
    END IF
    END IF

  CASE 3
     IF CH$ = CHR$(13) THEN Quit = 1
     IF MY >= 108 AND MY <= 117 THEN
     IF MX >= 144 AND MX <= 175 THEN
     HotSpot = 10
     END IF
     END IF
     IF MLB1 = 1 THEN PHotSpot = HotSpot
    MakeBox 100, 85, 219, 121
    PrintVGA "User has disconnected!", 107, 90, 255, 254
    PrintVGA "Want to quit?", 130, 100, 255, 254
    DQBfPut B0, 144, 108, VARSEG(OKyesNobutton(0, 0)), VARPTR(OKyesNobutton(0, 0))
     IF PHotSpot = HotSpot THEN
     IF HotSpot = 10 THEN
     DQBfPut B0, 144, 108, VARSEG(OKyesNobutton(0, 1)), VARPTR(OKyesNobutton(0, 1))
     IF MLB1 = -1 THEN Quit = 1
     END IF
     END IF

  CASE 4
     IF CH$ = CHR$(13) OR CH$ = CHR$(27) THEN
      Alert = 0
      REDIM GameBoard(13, 12) AS INTEGER
      REDIM WinRow(6) AS INTEGER
     END IF
     IF MY >= 101 AND MY <= 110 THEN
     IF MX >= 144 AND MX <= 175 THEN
      HotSpot = 10
     END IF
     END IF
     IF MLB1 = 1 THEN PHotSpot = HotSpot
    MakeBox 100, 85, 219, 114
    a$ = "Sorry, no winners!"
    PrintVGA a$, 118, 90, 251, 250
    DQBfPut B0, 144, 101, VARSEG(OKyesNobutton(0, 0)), VARPTR(OKyesNobutton(0, 0))
    IF PHotSpot = HotSpot THEN
    IF HotSpot = 10 THEN
    DQBfPut B0, 144, 101, VARSEG(OKyesNobutton(0, 1)), VARPTR(OKyesNobutton(0, 1))
    IF MLB1 = -1 THEN Alert = 0: REDIM GameBoard(13, 12) AS INTEGER: REDIM WinRow(6) AS INTEGER
    END IF
    END IF

 END SELECT
END IF

PALfadeBlack AlertStep, 0, 223

END SUB

REM $STATIC
SUB CheckForCollide

x = Player(3, REMOTE)
Y = Player(2, REMOTE)
IF Y THEN
 XX = x \ 16 + 3
 YY = (Y - 16) \ 16 + 3

 IF Y = 96 THEN
   GameBoard(XX, YY) = 1 + PlayersTurn
   Player(2, REMOTE) = 0
   a = CheckForWinner
   PlayersTurn = PlayersTurn XOR 1
   REMOTE = PlayersTurn
   IF PlayersTurn = 0 AND HandPosSent = 0 THEN
     iRetVal = SendData(0, "HANDX:" + LTRIM$(STR$(Player(1, 0))) + CR)
     HandPosSent = 1
   END IF
 END IF

 IF GameBoard(XX, YY + 1) AND Y >= 16 THEN
  GameBoard(XX, YY) = 1 + PlayersTurn
  Player(2, REMOTE) = 0
  a = CheckForWinner
  PlayersTurn = PlayersTurn XOR 1
  REMOTE = PlayersTurn
  IF PlayersTurn = 0 AND HandPosSent = 0 THEN
    iRetVal = SendData(0, "HANDX:" + LTRIM$(STR$(Player(1, 0))) + CR)
    HandPosSent = 1
  END IF
 END IF

END IF

END SUB

REM $DYNAMIC
FUNCTION CheckForWinner

'' Check all row combinations for winners.

FOR x = 3 TO 9
FOR Y = 3 TO 8
 C = GameBoard(x, Y)
 IF C THEN
   FOR Dir = 0 TO 7
      Yes = 1
      XX = x
      YY = Y
      SELECT CASE Dir
       CASE 0: IncX = 1: IncY = 0
       CASE 1: IncX = 1: IncY = 1
       CASE 2: IncY = 1: IncX = 0
       CASE 3: IncY = 1: IncX = -1
       CASE 4: IncX = -1: IncY = 0
       CASE 5: IncX = -1: IncY = -1
       CASE 6: IncY = -1: IncX = 0
       CASE 7: IncY = -1: IncX = 1
      END SELECT
CheckAgain:
      WinRow(Yes - 1) = ((YY - 3) * 7) + (XX - 3) + 1
      XX = XX + IncX
      YY = YY + IncY
      IF GameBoard(XX, YY) = C THEN Yes = Yes + 1: GOTO CheckAgain
	IF Yes >= 4 THEN
	CheckForWinner = C
	Player(4, REMOTE) = Player(4, REMOTE) + 1
	Alert = 2
	EXIT FUNCTION
	END IF
   NEXT
 END IF
NEXT
NEXT

'' Is the game all filled up with pieces and no winners?

FOR x = 3 TO 9
FOR Y = 3 TO 8
 IF GameBoard(x, Y) THEN Full = Full + 1
NEXT
NEXT
IF Full = 42 THEN Alert = 4

END FUNCTION

REM $STATIC
SUB CheckGameStatus

'' Update coordinates for Y if falling
IF Player(2, REMOTE) THEN
 IF Player(2, REMOTE) < 16 THEN
  Player(2, REMOTE) = Player(2, REMOTE) + 1
 ELSE
  Player(2, REMOTE) = Player(2, REMOTE) + 2
 END IF
END IF

IF PlayersTurn = 0 THEN           '' Update STATUS
 PlayerStatus = 1                 '' LOCAL's turn
ELSE
 PlayerStatus = 2                 '' REMOTE's turn
END IF

IF PlayerStatus = REMOTE + 1 THEN              '' Who gets to move?
IF Player(2, REMOTE) = 0 AND REMOTE = 0 THEN   '' Is piece already dropped?
 IF (CTRL = 1 OR ALT = 1) THEN
 IF SafeToPut THEN
 Player(2, REMOTE) = 1                         '' CTRL+ALT drops piece
 iRetVal = SendData(0, "DROP:" + LTRIM$(STR$(Player(3, REMOTE))) + CR)
 END IF
 END IF
 IF MX < 128 AND MY < 144 THEN
  IF MLB1 = 1 AND MX >= 16 THEN
   IF SafeToPut THEN
   Player(2, REMOTE) = 1                       '' Falling piece moving now
   iRetVal = SendData(0, "DROP:" + LTRIM$(STR$(Player(3, REMOTE))) + CR)
   END IF
  END IF
 END IF
END IF
END IF

'' Update coordinates for X saved
IF Player(2, REMOTE) THEN
 JX = Player(3, REMOTE)
 SELECT CASE JX
  CASE 1 TO 8: JX = JX - 1
  CASE 9 TO 15: JX = JX + 1
  CASE 17 TO 24: JX = JX - 1
  CASE 25 TO 31: JX = JX + 1
  CASE 33 TO 40: JX = JX - 1
  CASE 41 TO 47: JX = JX + 1
  CASE 49 TO 56: JX = JX - 1
  CASE 57 TO 63: JX = JX + 1
  CASE 65 TO 72: JX = JX - 1
  CASE 73 TO 79: JX = JX + 1
  CASE 81 TO 88: JX = JX - 1
  CASE 89 TO 95: JX = JX + 1
 END SELECT
 Player(3, REMOTE) = JX
END IF

IF Player(2, REMOTE) > 144 THEN Player(2, REMOTE) = 0  '' REMOVE

END SUB

FUNCTION CloseSock% (sHandle AS INTEGER)

 IF Sock(sHandle).State = 7 THEN
   iRetVal = shutdown(Sock(sHandle).Handle, 2)
 END IF
 iRetVal = closesocket(Sock(sHandle).Handle)

 Sock(sHandle).State = 0

END FUNCTION

REM POINT($DYNAMIC,  )
SUB ConnectMe (IP.address$)

' MARCADE, you can fill in the rest here

END SUB

FUNCTION ConnectTo% (sHandle AS INTEGER, stHostName AS STRING, iPort AS INTEGER)

DIM iaHost AS INADDR
DIM lHostPointer AS LONG
DIM SocketAddress AS sockaddrIn
DIM stTemp AS STRING

 ' Check if socket is ready
 IF Sock(sHandle).State <> 2 THEN ConnectTo% = -1: EXIT FUNCTION

iaHost.Saddr = inetAddr(stHostName)
IF (iaHost.Saddr = INADDR.NONE) THEN
  '' Wasn't an IP address string, assume it is a name
  lHostPointer = gethostbyname(stHostName)
  IF (lHostPointer = NULL) THEN
    PRINT "[ERROR] " + STR$(WSAGetLastError) + " Calling: gethostbyname()"
    ConnectTo% = -1
    EXIT FUNCTION
  END IF
 ELSE
  '' It was a valid IP address string
  lHostPointer = gethostbyaddr(iaHost, LEN(iaHost), AF.INET)
  IF (lHostPointer = NULL) THEN
    PRINT "[ERROR] " + STR$(WSAGetLastError) + " Calling: gethostbyaddr()"
    ConnectTo% = -1
    EXIT FUNCTION
  END IF
  stTemp = hostent.hName(lHostPointer)
  'PrintMsg 0, "-- Server name:" + stTemp + ".", 9
END IF

 SocketAddress.sinFamily = 2
 SocketAddress.sinAddr.Saddr = hostent.hAddrList(lHostPointer)
 SocketAddress.sinPort = htons(iPort)
 
 iRetVal = connect(Sock(sHandle).Handle, SocketAddress, LEN(SocketAddress))
 IF iRetVal = -1 THEN
   IF WSAGetLastError <> 10035 THEN
     PRINT "[ERROR] Could not create a connection!"
     PRINT "Errorcode:" + STR$(WSAGetLastError)
     ConnectTo% = -1
     iRetVal = closesocket(Sock(sHandle).Handle)
     EXIT FUNCTION
   END IF
 END IF

 Sock(sHandle).State = 6

END FUNCTION

REM $DYNAMIC
SUB CustomInput (Text$, Char$, CurPos, Length)

'' Modify string
C = LEN(Text$)
M = CurPos: IF M = -1 THEN CurPos = C
IF CurPos > C THEN CurPos = C
SELECT CASE Char$
CASE CHR$(8)
   IF C AND CurPos > 0 THEN
    CurPos = CurPos - 1
    AAL$ = LEFT$(Text$, CurPos)
    AAR$ = RIGHT$(Text$, C - CurPos - 1)
    Text$ = AAL$ + AAR$
   END IF
CASE CHR$(0) + CHR$(71): CurPos = 0
CASE CHR$(0) + CHR$(75): CurPos = CurPos + (CurPos > 0)
CASE CHR$(0) + CHR$(77): CurPos = CurPos - (CurPos < C)
CASE CHR$(0) + CHR$(79): CurPos = C
CASE CHR$(0) + CHR$(83)
 IF CurPos < C THEN
  AAL$ = LEFT$(Text$, CurPos)
  AAR$ = RIGHT$(Text$, LEN(Text$) - CurPos - 1)
  Text$ = AAL$ + AAR$
 END IF
END SELECT

'' Add to text string
IF LEN(Char$) = 1 THEN
IF ASC(Char$) > 31 AND CurPos < Length THEN
   IF INS THEN
    IF CurPos < C THEN MID$(Text$, CurPos + 1, 1) = Char$
    IF CurPos = C THEN Text$ = Text$ + Char$
   ELSE
    AAL$ = LEFT$(Text$, CurPos)
    AAR$ = RIGHT$(Text$, C - CurPos)
    Text$ = LEFT$(AAL$ + Char$ + AAR$, Length)
   END IF
  CurPos = CurPos + 1
END IF
END IF
IF M = -1 THEN CurPos = C

END SUB

REM $STATIC
SUB DrawGraphics

'' Draw message system
DQBboxf B0, 0, 160, 319, 189, 252
DQBfPut B0, 288, 190, VARSEG(SendButton(0, 0)), VARPTR(SendButton(0, 0))
FOR I = -1 TO 3
 y1 = ScrollY MOD 10
 y2 = ScrollY \ 10
  Text$ = Messages(I + 13 - y2)
  L = LEN(Text$)
  Col$ = RIGHT$(Text$, 1)
   IF L THEN Text$ = LEFT$(Text$, L - 1)
   IF Col$ = CHR$(1) THEN C = 2 ELSE C = 0
   PrintVGA Text$, 1, 161 + (I * 10) + y1, 251 - C, 250 - C
NEXT
DQBboxf B0, 288, 160, 319, 189, 252
IF NumbMess > 3 THEN
 DQBboxf B0, 288, 171, 298, 178, 253
 DQBfPut B0, 288, 160, VARSEG(ScrollArrows(0, 0)), VARPTR(ScrollArrows(0, 0))
 DQBfPut B0, 288, 179, VARSEG(ScrollArrows(0, 2)), VARPTR(ScrollArrows(0, 2))
END IF
DQBfPut B0, 304, 166, VARSEG(EXITbutton(0, 0)), VARPTR(EXITbutton(0, 0))
IF MLB1 AND HotSpot = PHotSpot THEN
SELECT CASE HotSpot
 CASE 1: DQBfPut B0, 288, 160, VARSEG(ScrollArrows(0, 1)), VARPTR(ScrollArrows(0, 1))
 CASE 2: DQBfPut B0, 288, 179, VARSEG(ScrollArrows(0, 3)), VARPTR(ScrollArrows(0, 3))
 CASE 3: DQBfPut B0, 288, 190, VARSEG(SendButton(0, 1)), VARPTR(SendButton(0, 1))
 CASE 4: DQBfPut B0, 304, 166, VARSEG(EXITbutton(0, 1)), VARPTR(EXITbutton(0, 1))
END SELECT
END IF

'' Draw Text input box
DQBboxf B0, 0, 190, 287, 199, 253

'' Draw TOPs
DQBboxf B0, 144, 0, 159, 143, 192
DQBfPut B0, 0, 0, VARSEG(BackGFX(0)), VARPTR(BackGFX(0))
DQBfPut B0, 176, 0, VARSEG(Board(0)), VARPTR(Board(0))
DQBfPut B0, 160, 144, VARSEG(ExtraGFX(0, 1)), VARPTR(ExtraGFX(0, 1))

'' Draw animated sprites
FF = FrameTile \ 4
IF FF >= 8 THEN FF = 15 - FF
DQBput B0, 208, 80, VARSEG(Pieces(0, FF, 0)), VARPTR(Pieces(0, FF, Player(0, 0)))
DQBput B0, 208, 112, VARSEG(Pieces(0, FF, 1)), VARPTR(Pieces(0, FF, Player(0, 1)))

'' Draw Hand
DQBput B0, Player(1, REMOTE), 0, VARSEG(Hand(0, 0)), VARPTR(Hand(0, 0))
C = Player(0, PlayersTurn)
DQBput B0, Player(3, REMOTE) + 16, 32 + Player(2, REMOTE), VARSEG(Pieces(0, 0, C)), VARPTR(Pieces(0, 0, C))
DQBput B0, Player(1, REMOTE) + 16, 0, VARSEG(Hand(0, 1)), VARPTR(Hand(0, 1))

'' Put the bars up for blurring
DQBfPut B0, 0, 144, VARSEG(BottomBar(0)), VARPTR(BottomBar(0))
DQBfPut B0, 160, 0, VARSEG(RightBar(0)), VARPTR(RightBar(0))

'' Blur bars RIGHT
FOR Y = 2 TO 142
DEF SEG = DQBmapLayer(B0) + ((Y - 1) * 20&)
FOR x = 161 TO 174
 POKE x + 320, Div4(PEEK(x + 319) + PEEK(x + 321) + PEEK(x + 640) + PEEK(x))
NEXT
NEXT
' BOTTOM
FOR Y = 145 TO 158
DEF SEG = DQBmapLayer(B0) + ((Y - 1) * 20&)
FOR x = 2 TO 158
 POKE x + 320, Div4(PEEK(x + 319) + PEEK(x + 321) + PEEK(x + 640) + PEEK(x))
NEXT
NEXT

'' Bar lightning
DEF SEG = DQBmapLayer(B0) + 2880
y2 = INT(RND * 14) + 1
FOR x = 2 TO 158
 y1 = INT(RND * 3) - 1
 y2 = y2 + y1
 IF y2 < 1 THEN y2 = 1
 IF y2 > 14 THEN y2 = 14
 POKE y2 * 320& + x, 63
NEXT

x2 = INT(RND * 14) + 1
FOR Y = 2 TO 142
 x1 = INT(RND * 3) - 1
 x2 = x2 + x1
 IF x2 < 1 THEN x2 = 1
 IF x2 > 14 THEN x2 = 14
 DQBpset B0, x2 + 160, Y, 63
NEXT

'' Grab the DATA for later use
DQBget B0, 0, 144, 159, 159, VARSEG(BottomBar(0)), VARPTR(BottomBar(0))
DQBget B0, 160, 0, 175, 143, VARSEG(RightBar(0)), VARPTR(RightBar(0))

'' Draw game board with pieces
FOR Y = 0 TO 5
FOR x = 0 TO 6
XX = x * 16 + 16
YY = Y * 16 + 48
IF GameBoard(x + 3, Y + 3) THEN
  C = Player(0, GameBoard(x + 3, Y + 3) - 1)
  IF C = 0 OR C = 1 THEN DQBput B0, XX, YY, VARSEG(Pieces(0, 0, C)), VARPTR(Pieces(0, 0, C))
 IF Alert = 2 THEN
  FOR PP = 0 TO 6
  IF WinRow(PP) = Y * 7 + x + 1 THEN
  IF C = 0 OR C = 1 THEN DQBput B0, XX, YY, VARSEG(Pieces(0, FF, C)), VARPTR(Pieces(0, FF, C))
  END IF
  NEXT
 END IF
END IF

DQBput B0, XX, YY, VARSEG(ExtraGFX(0, 0)), VARPTR(ExtraGFX(0, 0))
NEXT
NEXT

'' Status
a$ = PlayerNames(PlayerStatus - 1)
IF UCASE$(RIGHT$(a$, 1)) <> "S" THEN
a$ = a$ + "'s"
ELSE
a$ = a$ + "'"
END IF

PrintVGA "SCORE:", 240, 18, 133, 130
DQBPrint B0, STR$(Player(4, 0)), 220, 28, 160 + (Player(0, 0) * 19)
DQBPrint B0, STR$(Player(4, 1)), 260, 28, 160 + (Player(0, 1) * 19)
PrintVGA a$, 220, 41, 190, 142
PrintVGA "turn", 220, 51, 190, 142

'' Draw Text input
PrintVGA InputText$, 1, 191, 255, 254
DQBPrint B0, PlayerNames(0), 228, 81, 160 + (Player(0, 0) * 19)
DQBPrint B0, PlayerNames(1), 228, 113, 160 + (Player(0, 1) * 19)

'' Fade In
IF FADE THEN
 FADE = 0
  FOR I = 0 TO 63
  PALfadeBlack 63 - I, 0, 255
  EndLoop
  NEXT
END IF

END SUB

FUNCTION DSOCKlisten

DIM saServer AS sockaddrIn
DIM Port AS INTEGER

Port = 2244

Sock(1).Handle = socket(2, 1, 6)
IF (Sock(1).Handle = 0) THEN
  PRINT "ERRO! socket()"; WSAGetLastError
  EXIT FUNCTION
  DSOCKlisten = -1
END IF
    
saServer.sinFamily = 2
saServer.sinAddr.Saddr = INADDR.ANY
saServer.sinPort = htons(Port)

nRet = bind(Sock(1).Handle, saServer, LEN(saServer))
IF (nRet <= -1) THEN
  PRINT "ERROR! bind()"; WSAGetLastError
  nRet = closesocket(Sock(1).Handle)
  DSOCKlisten = -1
  EXIT FUNCTION
END IF
       
nRet = listen(Sock(1).Handle, 1)
IF (nRet <= -1) THEN
  PRINT "ERROR! listen()"; WSAGetLastError
  nRet = closesocket(Sock(1).Handle)
  DSOCKlisten = -1
  EXIT FUNCTION
END IF

Sock(1).State = 4

END FUNCTION

FUNCTION DSOCKPoll%

DIM rfds(0 TO UBOUND(Sock)) AS LONG
DIM wfds(0 TO UBOUND(Sock)) AS LONG
DIM efds(0 TO UBOUND(Sock)) AS LONG
DIM TimeOutValues AS timeval

DIM iTemp AS INTEGER, sHandle AS INTEGER

DIM sa AS sockaddrIn, lensa AS INTEGER

 TimeOutValues.tvSec = 0
 TimeOutValues.tvUsec = 0

 FOR iTemp = 0 TO UBOUND(Sock)
  IF Sock(iTemp).State >= 4 AND Sock(iTemp).State < 8 THEN
    rfds(0) = rfds(0) + 1: rfds(rfds(0)) = Sock(iTemp).Handle
    wfds(0) = wfds(0) + 1: wfds(rfds(0)) = Sock(iTemp).Handle
    efds(0) = efds(0) + 1: efds(rfds(0)) = Sock(iTemp).Handle
   
    IF Sock(iTemp).State = 7 THEN Sock(iTemp).State = 8' Put them on disconnected status
  END IF
 NEXT iTemp

 IF rfds(0) = 0 AND wfds(0) = 0 AND efds(0) = 0 THEN
   EXIT FUNCTION
 END IF


 iRetVal = selectsocket(0, rfds(0), wfds(0), efds(0), TimeOutValues)

 IF iRetVal = 0 THEN EXIT FUNCTION

 IF iRetVal < 0 THEN
   PRINT "Error polling sockets!"
   PRINT "Errorcode:" + STR$(WSAGetLastError)
   PollSocks% = -1
   EXIT FUNCTION
 END IF

 IF rfds(0) > 0 THEN
   FOR iTemp = 1 TO rfds(0)
    sHandle = GetSockByHandle(rfds(iTemp))
    IF sHandle > -1 THEN
      SELECT CASE Sock(sHandle).State
       CASE 4
	lensa = LEN(sa)
	Sock(0).Handle = accept(Sock(sHandle).Handle, sa, lensa)
	IF Sock(0).Handle = -1 THEN
	  PRINT "[ERROR] Could not accept incoming connection."
	  PRINT "Errorcode:" + STR$(WSAGetLastError)
	  iRetVal = CloseSock(0)
	  QuitEntireProgram
	END IF
	Sock(0).OldState = 0
	Sock(0).State = 6
	Sock(sHandle).State = 0
	'Close the listening Socket
	'iRetVal = CloseSock(sHandle)
       CASE 6
	Sock(sHandle).State = 7
	SockReceiveData sHandle
       CASE 7
	Sock(sHandle).State = 7
	SockReceiveData sHandle
       CASE 8
	Sock(sHandle).State = 7
	SockReceiveData sHandle
       CASE ELSE ' Unknown feature
	iRetVal = CloseSock(sHandle)
      END SELECT
    END IF
   NEXT iTemp
 END IF
 IF wfds(0) > 0 THEN
   FOR iTemp = 1 TO wfds(0)
    sHandle = GetSockByHandle(wfds(iTemp))
    IF sHandle > -1 THEN
      SELECT CASE Sock(sHandle).State
       CASE 6
	Sock(sHandle).State = 7
	SockSendData (sHandle)
       CASE 7
	Sock(sHandle).State = 7
	SockSendData (sHandle)
       CASE 8
	Sock(sHandle).State = 7
	SockSendData (sHandle)
       CASE ELSE ' Unknown feature
	iRetVal = CloseSock(sHandle)
      END SELECT
    END IF
   NEXT iTemp
 END IF
 IF efds(0) > 0 THEN
   FOR iTemp = 1 TO efds(0)
    sHandle = GetSockByHandle(efds(iTemp))
    IF sHandle > -1 THEN
      iRetVal = CloseSock(sHandle)
    END IF
   NEXT iTemp
 END IF

' IF OldTimer <> INT(TIMER) THEN
'   OldTimer = INT(TIMER)
'
'   PRINT "Read:" + STR$(rfds(0)) + "  Write:" + STR$(wfds(0)) + "  OOB:" + STR$(efds(0))
'   PRINT "-----------------------------------------------------"
'   FOR iTemp = 0 TO 1
'     PRINT "R:" + STR$(rfds(iTemp)) + "      W:" + STR$(wfds(iTemp)) + "     O:" + STR$(efds(iTemp))
'   NEXT iTemp

END FUNCTION

SUB EndLoop

'' Blit
DQBwait 1
OUT &H3C8, 0
FOR I = 0 TO 255
OUT &H3C9, SCR(I, 0)
OUT &H3C9, SCR(I, 1)
OUT &H3C9, SCR(I, 2)
NEXT
DQBcopyLayer B0, 0

END SUB

SUB GetInput

'' Keys and loop
FrameTile = (FrameTile + 1) AND 63
CH$ = INKEY$

'' Always reset hotspots
HotSpot = 0
IF MLB1 = 0 THEN PHotSpot = 0

'' Insert, ctrl, and alt key
DEF SEG = 65
C = (PEEK(7) AND 1) OR (PEEK(7) AND 2)
IF PEEK(7) AND 128 THEN INS = 1 ELSE INS = 0
IF CTRL = -1 THEN CTRL = 0
IF ALT = -1 THEN ALT = 0
C = (PEEK(8) AND 1) OR (PEEK(134) AND 4)
IF C THEN CTRL = CTRL - (CTRL < 2) ELSE IF CTRL THEN CTRL = -1
C = (PEEK(8) AND 2) OR (PEEK(134) AND 8)
IF C THEN ALT = ALT - (ALT < 2) ELSE IF ALT THEN ALT = -1

'' Grab input from mouse or keyboard
IF Mouse THEN
 PMX = MX
 PMY = MY
 MX = DQBmouseX
 MY = DQBmouseY
 LB = DQBmouseLB
 C = MX - 24
 IF PMX = MX AND PMY = MY THEN C = Player(1, 0)
END IF

'' Scroll message with UP/DOWN key and move hand
SELECT CASE INP(96)
 CASE 72
  IF NumbMess > 3 THEN ScrollY = ScrollY - (ScrollY < ((NumbMess - 3) * 10))
 CASE 75
  IF REMOTE = 0 THEN C = C - 1
 CASE 77
  IF REMOTE = 0 THEN C = C + 1
 CASE 80
  ScrollY = ScrollY + (ScrollY > 0)
END SELECT


'' Correct coordinates
IF C < 0 THEN C = 0
IF C > 96 THEN C = 96
Player(1, 0) = C
IF Player(2, 0) = 0 THEN Player(3, 0) = C

IF PlayersTurn = 0 AND HandPosSent = 0 THEN
  ' AND ABS(HandLastSent - TIMER) > .1
  HandLastSent = TIMER
  iRetVal = SendData(0, "HANDX:" + LTRIM$(STR$(Player(1, 0))) + CR)
  HandPosSent = 1
END IF

'' Mouse released or pressed?
IF MLB1 = -1 THEN MLB1 = 0
IF LB THEN MLB1 = MLB1 - (MLB1 < 2) ELSE IF MLB1 THEN MLB1 = -1

END SUB

FUNCTION GetLocalIP$

DIM lpHostEntry AS LONG
DIM hostName AS STRING
DIM IPAddress AS STRING
hostName = SPACE$(32)

IF (gethostname(hostName, LEN(hostName)) = -1) THEN
  PRINT "gethostname():"; WSAGetLastError
  QuitEntireProgram
END IF

 lpHostEntry = gethostbyname(hostName)
 IF (lpHostEntry = 0) THEN
   PRINT "gethostbyname():"; WSAGetLastError
   QuitEntireProgram
 END IF

 IPAddress = inetNtoa(hostent.hAddrList(lpHostEntry))

 GetLocalIP$ = IPAddress

END FUNCTION

FUNCTION GetSockByHandle% (sHandle AS LONG)
DIM iTemp AS INTEGER

 FOR iTemp = 0 TO UBOUND(Sock)
  IF Sock(iTemp).Handle = sHandle THEN EXIT FOR
 NEXT iTemp
 IF iTemp > UBOUND(Sock) THEN GetSockByHandle% = -1: EXIT FUNCTION
 GetSockByHandle% = iTemp

END FUNCTION

SUB Init

'' Initiate DQB and use RND later on
IF DQBinit(0, 0, 0) THEN DQBclose: PRINT DQBerror$: END
RANDOMIZE TIMER

'' Load up SMALL.FNT
IF DQBloadFont("SMALL.FNT") THEN DQBclose: PRINT DQBerror$: END

'' Mouse detection
Mouse = ABS(DQBmouseDetected)
IF Mouse THEN DQBsetMousePos 48, 0

'' Make a DIVIDE by 4 table
FOR I = 0 TO 255
Div4(I) = I \ 4
NEXT

'' Double buffer using base memory
Q& = SETMEM(-200000)
IF DQBsetBaseLayer(B0) = 0 THEN
 DQBclose
 PRINT DQBerror$
 Q& = SETMEM(200000)
 END
END IF

'' Load up previously used input, if file exists:
OPEN "CONNECT4.INI" FOR BINARY AS #1: C& = LOF(1): CLOSE #1
IF C& THEN
  OPEN "CONNECT4.INI" FOR INPUT AS #1
   INPUT #1, IP.address$
   INPUT #1, YourName$
  CLOSE #1
  IP.address$ = LEFT$(LTRIM$(RTRIM$(IP.address$)), 16)
  YourName$ = LEFT$(LTRIM$(RTRIM$(YourName$)), 10)
  Cur1 = LEN(IP.address$)
  Cur2 = LEN(YourName$)
 ELSE
  KILL "CONNECT4.INI"
END IF

' MARCADE
DIM iRetVal AS INTEGER
DIM wsaDat AS WSaData

wVersionRequested = MAKEWORD(1, 1)
iRetVal = WSAStartup(wVersionRequested, wsaDat)

IF (wsaDat.wVersion <> wVersionRequested) THEN
  PRINT "[ERROR] Your version of winsock is not supported by DSock."
  QuitEntireProgram
END IF

IF DSOCKlisten THEN
  PRINT "[ERROR] Could not create a socket to listen."
  QuitEntireProgram
END IF


'' Need user input at beginning of program
CLS
 COLOR 9: PRINT "Welcome to ";
 COLOR 12: PRINT "CONNECT 4 QB";
 COLOR 9: PRINT " by WisdomDude AND Marcade."
 COLOR 12: PRINT "WinSock Version "; LTRIM$(STR$(wsaDat.wVersion \ 256)); "."; LTRIM$(STR$(wsaDat.wVersion AND &HFF))

 COLOR 14: PRINT "Your IP address: ";
 COLOR 15: PRINT GetLocalIP$: PRINT
 
 COLOR 10: PRINT "WAIT for user, or type in their IP address and hit enter:"

'' Type in IP address or wait
TempY = CSRLIN
DO
 GetInput
 CustomInput IP.address$, CH$, Cur1, 16
 IF LEN(IP.address$) AND CH$ = CHR$(13) THEN EXIT DO
 IF CH$ = CHR$(27) THEN QuitEntireProgram
 COLOR 14: LOCATE TempY, 1: PRINT "Their IP address: "
 COLOR 15: LOCATE TempY, 20: PRINT IP.address$ + "    "
 LOCATE TempY, 20 + Cur1, 1
 DQBwait 1
 ' MARCADE, I need a RemoteUser function to tell me if remoteUser connected first

IF DSOCKPoll% < 0 THEN
   PRINT "[ERROR] Polling sockets wend wrong."
 END IF

 IF Sock(0).State = 7 AND Sock(0).OldState <> 7 THEN
  PRINT "Connected!"
  Sock(0).OldState = 7
  RemoteUser = -1
 END IF

LOOP UNTIL RemoteUser
PRINT

'' Connect to remote user                    '' Since we connected first
IF CH$ = CHR$(13) AND RemoteUser = 0 THEN    '' our machine decides

iRetVal = CloseSock(1)                      '' Close the listening socket
 SockPrepare                                 '' Prepare Sock(0)
 iRetVal = ConnectTo%(0, IP.address$, 2244)  '' Connect to the thing
 IF iRetVal <= -1 THEN
   PRINT "[ERROR] Failed trying to connect."
   QuitEntireProgram
 END IF

 PRINT "Connecting .."
 RemoteUser = 0                              '' Loop until we are connected
 DO
  
  IF INKEY$ = CHR$(27) THEN QuitEntireProgram
  IF DSOCKPoll% < 0 THEN
    PRINT "[ERROR] Polling sockets wend wrong."
  END IF

  IF Sock(0).State = 7 AND Sock(0).OldState <> 7 THEN
   PRINT "Connected!"
   Sock(0).OldState = 7
   RemoteUser = -1
  END IF
 LOOP UNTIL RemoteUser

 PlayersTurn = CINT(RND)
 Player(0, 0) = PlayersTurn  ' MARCADE, Tell remote computer who
 Player(0, 1) = 1 - PlayersTurn     ' gets to be RED?. RED always goes first.

 IF PlayersTurn = 0 THEN iRetVal = SendData(0, "COLOR:RED" + CR)
 IF PlayersTurn = 1 THEN iRetVal = SendData(0, "COLOR:YELLOW" + CR)
 iRetVal = DSOCKPoll%

END IF

'''''''''''''''''''''''''''''''''''''''''''''''''''''
''''' From this point, we're now connected  '''''''''
'''''''''''''''''''''''''''''''''''''''''''''''''''''
'''''''''''''''''''''''''''''''''''''''''''''''''''''
PRINT "Connected"

'' Type in your name here
PRINT
TempY = CSRLIN

COLOR 10: PRINT "Type in your name (No more than 10 chars):": COLOR 15

DO
 GetInput
 CustomInput YourName$, CH$, Cur2, 10
 IF CH$ = CHR$(27) THEN QuitEntireProgram
 COLOR 15: LOCATE TempY, 44: PRINT YourName$ + "    "
 LOCATE TempY, 44 + Cur2, 1
 DQBwait 1

 IF DSOCKPoll% < 0 THEN
   PRINT "[ERROR] Polling sockets wend wrong."
 END IF
 IF Sock(0).State <> 7 THEN
  PRINT "Disconnect!"
  QuitEntireProgram
 END IF

LOOP UNTIL LEN(YourName$) AND CH$ = CHR$(13)

PRINT
PRINT "Waiting for remote user .."

' MARCADE, send remote computer our name, and get remote user's name

'' Load up previously used input, if file exists:
IP.address$ = LEFT$(LTRIM$(RTRIM$(IP.address$)), 16)
YourName$ = LEFT$(LTRIM$(RTRIM$(YourName$)), 10)
OPEN "CONNECT4.INI" FOR OUTPUT AS #1
 PRINT #1, IP.address$
 PRINT #1, YourName$
CLOSE #1

PlayerNames(0) = YourName$       ''  TEMPORARY
iRetVal = SendData(0, "NICK:" + YourName$ + CR)

DO
 IF INKEY$ = CHR$(27) THEN QuitEntireProgram
 IF DSOCKPoll% < 0 THEN
   PRINT "[ERROR] Polling sockets wend wrong."
 END IF
 IF Sock(0).State = 0 THEN
  PRINT "Disconnected!"
  QuitEntireProgram
 END IF
LOOP UNTIL LEN(PlayerNames(1)) > 0
PRINT "Received names. Starting game."

IF UCASE$(YourName$) = "MARCADE" THEN AddMessage "Marcade has implemented DSock!", 0
IF UCASE$(YourName$) = "MARCADE" THEN AddMessage "Marcade won the first match ever played.", 0

IF UCASE$(YourName$) = "WISDOMDUDE" THEN AddMessage "WisdomDude created and Connect4", 0
IF UCASE$(YourName$) = "WISDOMDUDE" THEN AddMessage "He created it in a mere 2 days!", 0

IF UCASE$(YourName$) = "V1CTOR" THEN AddMessage "V1ctor was the man that brought us DSock!", 0
IF UCASE$(YourName$) = "V1CTOR" THEN AddMessage "Thanks to him, the QB-Community has entered a new era.", 0
IF UCASE$(YourName$) = "V1CTOR" THEN AddMessage "The internet era!", 0

IF UCASE$(YourName$) = "BLITZ" THEN AddMessage "Blitz also was very helpful.", 0


'' Initiate VGA mode
DQBinitVGA
OUT &H3C8, 0
FOR I = 0 TO 255
OUT &H3C9, 0
OUT &H3C9, 0
OUT &H3C9, 0
NEXT

'' Grab all sprites
DEF SEG = &HA000
BLOAD "CONNECT4.BIN"
DQBget 0, 32, 48, 175, 191, VARSEG(BackGFX(0)), VARPTR(BackGFX(0))
DQBget 0, 176, 0, 319, 159, VARSEG(Board(0)), VARPTR(Board(0))
FOR I = 0 TO 1
 C = I * 16
 DQBget 0, 32, C, 47, C + 15, VARSEG(ExtraGFX(0, I)), VARPTR(ExtraGFX(0, I))
 DQBget 0, C, 170, C + 15, 185, VARSEG(EXITbutton(0, I)), VARPTR(EXITbutton(0, I))
 C = (I * 10) + 150
 DQBget 0, 0, C, 31, C + 9, VARSEG(SendButton(0, I)), VARPTR(SendButton(0, I))
 C = I * 48
 DQBget 0, 80 + C, 0, 127 + C, 47, VARSEG(Hand(0, I)), VARPTR(Hand(0, I))
   FOR C = 0 TO 7
   DQBget 0, I * 16, C * 16, I * 16 + 15, C * 16 + 15, VARSEG(Pieces(0, C, I)), VARPTR(Pieces(0, C, I))
   NEXT
NEXT
DQBget 0, 32, 32, 47, 47, VARSEG(ExtraGFX(0, 2)), VARPTR(ExtraGFX(0, 2))
DQBget 0, 0, 128, 10, 138, VARSEG(ScrollArrows(0, 0)), VARPTR(ScrollArrows(0, 0))
DQBget 0, 0, 139, 10, 149, VARSEG(ScrollArrows(0, 1)), VARPTR(ScrollArrows(0, 1))
DQBget 0, 11, 128, 21, 138, VARSEG(ScrollArrows(0, 2)), VARPTR(ScrollArrows(0, 2))
DQBget 0, 11, 139, 21, 149, VARSEG(ScrollArrows(0, 3)), VARPTR(ScrollArrows(0, 3))
FOR I = 0 TO 2
C = I * 32 + 176
DQBget 0, C, 160, C + 31, 169, VARSEG(OKyesNobutton(0, I * 2)), VARPTR(OKyesNobutton(0, I * 2))
DQBget 0, C, 170, C + 31, 179, VARSEG(OKyesNobutton(0, I * 2 + 1)), VARPTR(OKyesNobutton(0, I * 2 + 1))
NEXT

'' Grab palette
DEF SEG = &HA000 + 3940
FOR I = 0 TO 255
 PALpcw I, PEEK(I), PEEK(I + 320), PEEK(I + 640)
NEXT
DQBwait 1
DQBclearLayer 0
DQBget B0, 0, 144, 159, 159, VARSEG(BottomBar(0)), VARPTR(BottomBar(0))
DQBget B0, 160, 0, 175, 143, VARSEG(RightBar(0)), VARPTR(RightBar(0))
DQBwait 1

'' Set the palette
FOR I = 64 TO 255
PALpcr I, R, G, B
PALscw I, R, G, B
NEXT

END SUB

FUNCTION Interpolate (Number1, Number2, Value, MaxValue)

IF Number1 = Number2 THEN Interpolate = Number1: EXIT FUNCTION

IF Number1 < Number2 THEN
 Dist& = Number2 - Number1
 Interpolate = (Value * Dist& / MaxValue) + Number1
ELSE
 Dist& = Number1 - Number2
 Interpolate = Number1 - (Value * Dist& / MaxValue)
END IF

END FUNCTION

SUB MakeBox (x1%, y1%, x2%, y2%)

FOR I = 0 TO 2
DQBbox B0, x1 + I, y1 + I, x2 - I, y2 - I, 244 + I
NEXT
DQBboxf B0, x1 + 3, y1 + 3, x2 - 3, y2 - 3, 239

END SUB

SUB Messaging

C = LEN(InputText$)
IF DQBlen(InputText$) < 276 THEN C = 160
CustomInput InputText$, CH$, -1, C
IF CH$ = CHR$(13) AND LEN(InputText$) THEN
 IF SendData(0, "MESSAGE:" + InputText$ + CR) THEN
   PRINT "[ERROR] Could not send message"
   SLEEP
  ELSE
   FOR I = 0 TO 14
    Messages(I) = Messages(I + 1)
   NEXT
   Messages(15) = InputText$ + CHR$(Player(0, 0))
   InputText$ = ""
   NumbMess = NumbMess - (NumbMess < 16)
   ScrollY = 0
 END IF
END IF

END SUB

SUB MouseInput

'' Button touching
IF MX >= 288 AND MX <= 298 THEN
 IF MY >= 160 AND MY <= 170 THEN HotSpot = 1
 IF MY >= 179 AND MY <= 189 THEN HotSpot = 2
END IF
IF MX >= 288 AND MY >= 190 THEN HotSpot = 3
IF MX >= 304 AND MY >= 166 AND MY <= 181 THEN HotSpot = 4
IF MLB1 = 1 THEN PHotSpot = HotSpot

'' Scroll buttons
IF MLB1 AND HotSpot = PHotSpot THEN
SELECT CASE HotSpot
 CASE 1
  IF NumbMess > 3 THEN ScrollY = ScrollY - (ScrollY < ((NumbMess - 3) * 10))
 CASE 2: ScrollY = ScrollY + (ScrollY > 0)
 CASE 3: IF MLB1 = -1 THEN CH$ = CHR$(13)
 CASE 4: IF MLB1 = -1 THEN CH$ = CHR$(27)
END SELECT
END IF

END SUB

SUB Notes

'' DATA TO EXCHANGE BETWEEN COMPUTERS:

'' PlayersTurn = REMOTE or LOCAL PLAYER's TURN?
'' PlayerStatus = Shared status between machines
'' PlayerNames(0) = LOCAL NICK NAME
'' PlayerNames(1) = REMOTE NICK NAME

'' x = 0 = LOCAL USER
'' x = 1 = REMOTE USER
'' Player(0, x) = Is local player, player 1 (red=0) OR player 2 (yellow=1)?
'' Player(1, x) = X Coordinate of players hand
'' Player(2, x) = Y Coordinate of dropping piece
'' Player(3, x) = X Saved coordinate of falling piece
'' Player(4, x) = Wins of player

END SUB

SUB PALfadeBlack (Level, ColA, ColB)

FOR I = ColA TO ColB
 PALpcr I, R, G, B
 R = Interpolate(R, 0, Level, 63)
 G = Interpolate(G, 0, Level, 63)
 B = Interpolate(B, 0, Level, 63)
 PALscw I, R, G, B
NEXT

END SUB

SUB PalLightning

'' Lightning color

ColTile = (ColTile + 1) AND 511
SELECT CASE ColTile
CASE 0 TO 63
  R = 63
  G = 0
  B = ColTile

CASE 64 TO 127
  R = 127 - ColTile
  G = 0
  B = 63


CASE 128 TO 191
  R = 0
  G = ColTile - 128
  B = 63
CASE 192 TO 255
  R = 0
  G = 63
  B = 255 - ColTile
CASE 256 TO 319
  R = ColTile - 256
  G = 63
  B = 0
CASE 320 TO 383
  R = 63
  G = 383 - ColTile
  B = 0
CASE 384 TO 447
  R = 63
  G = ColTile - 384
  B = ColTile - 384
CASE 448 TO 511
  R = 63
  G = 511 - ColTile
  B = 511 - ColTile
END SELECT

'' Add it to our buffer
FOR I = 0 TO 63
RR = R * I \ 63
GG = G * I \ 63
BB = B * I \ 63
PALpcw I, RR, GG, BB
PALscw I, RR, GG, BB
NEXT


END SUB

SUB PALpcr (I, R, G, B)

R = Pal(I, 0)
G = Pal(I, 1)
B = Pal(I, 2)

END SUB

SUB PALpcw (I, R, G, B)

IF R > 63 THEN R = 63
IF G > 63 THEN G = 63
IF B > 63 THEN B = 63
IF R < 0 THEN R = 0
IF G < 0 THEN G = 0
IF B < 0 THEN B = 0
Pal(I, 0) = R
Pal(I, 1) = G
Pal(I, 2) = B

END SUB

SUB PALscr (I, R, G, B)

R = SCR(I, 0)
G = SCR(I, 1)
B = SCR(I, 2)

END SUB

SUB PALscw (I, R, G, B)

IF R > 63 THEN R = 63
IF G > 63 THEN G = 63
IF B > 63 THEN B = 63
IF R < 0 THEN R = 0
IF G < 0 THEN G = 0
IF B < 0 THEN B = 0
SCR(I, 0) = R
SCR(I, 1) = G
SCR(I, 2) = B

END SUB

SUB PrintVGA (Text$, x, Y, FG, BG)               ' Print stuff

DQBPrint B0, Text$, x + 1, Y + 1, BG
DQBPrint B0, Text$, x, Y, FG

END SUB

SUB ProcessData (sHandle AS INTEGER)

 DIM stReceived AS STRING
 DIM stIncoming AS STRING

 stReceived = LEFT$(Sock(sHandle).Received, Sock(sHandle).ReceivedBytes)

 ' Check if we received a complete line yet, if not, leave the routine
 IF INSTR(stReceived, CR) = 0 THEN EXIT SUB

 WHILE INSTR(stReceived, CR) > 0
  stIncoming = LEFT$(stReceived, INSTR(stReceived, CR) - 1)
  stReceived = MID$(stReceived, INSTR(stReceived, CR) + 2)

  ProcessRemoteAction stIncoming

 WEND

 ' Put the leftover data back in the buffer.
 Sock(sHandle).Received = stReceived
 Sock(sHandle).ReceivedBytes = LEN(stReceived)

END SUB

SUB ProcessRemoteAction (stAction AS STRING)

 DIM stName AS STRING, stValue AS STRING

 stAction = LTRIM$(RTRIM$(stAction))
 IF stAction = "" THEN EXIT SUB
 stName = stAction
 IF INSTR(stName, ":") > 0 THEN
  stValue = MID$(stName, INSTR(stName, ":") + 1)
  stName = LEFT$(stName, INSTR(stName, ":") - 1)
 END IF

 ' Remote user has sent us something.
 SELECT CASE stName
  CASE "BYE"
   Alert = 3
   stName = ""
  CASE "COLOR" ' The remote user chooses to be red
   IF stValue = "RED" THEN
     Player(0, 0) = 1
     Player(0, 1) = 0
     PlayersTurn = 1
     REMOTE = 1
     stName = ""
    ELSEIF stValue = "YELLOW" THEN
     Player(0, 0) = 0
     Player(0, 1) = 1
     PlayersTurn = 0
     REMOTE = 0
     stName = ""
   END IF
  CASE "NICK" ' The remote user sends his nick
   PlayerNames(1) = stValue
   stName = ""
  CASE "MESSAGE" ' The remote user sends a message
   stAction = LTRIM$(RTRIM$(stValue))
  CASE "DROP" ' The remote user drops a chip
   Player(2, 1) = 1
   Player(3, 1) = VAL(stValue)
   stName = ""
  CASE "HANDX" ' The remote user tells us where his hand is
   Player(1, 1) = VAL(stValue)
   IF Player(2, 1) <= 0 THEN Player(3, 1) = Player(1, 1)
   iRetVal = SendData(0, "HANDOK:" + stValue + CR)
   stName = ""
  CASE "HANDOK" ' Acknowledgement of remote user on HANDX
   HandPosSent = 0
   IF Player(1, 0) <> VAL(stValue) AND PlayersTurn = 0 THEN
     ' AND ABS(HandLastSent - TIMER) > .1
     HandLastSent = TIMER
     iRetVal = SendData(0, "HANDX:" + LTRIM$(STR$(Player(1, 0))) + CR)
   END IF
   stName = ""
 END SELECT


 ' If stName is not empty, it is a message from the remote player
 ' Print it in the chatbox
 IF stName = "" THEN EXIT SUB

 AddMessage stAction, Player(0, 1)

END SUB

SUB QuitEntireProgram

IF Sock(0).State = 7 THEN
  iRetVal = SendData(0, "BYE" + CR)
  iRetVal = DSOCKPoll%
  iRetVal = DSOCKPoll%
  iRetVal = DSOCKPoll%
END IF

iRetVal = CloseSock(0)
iRetVal = CloseSock(1)

IF WSACleanup% THEN
  PRINT "[ERROR] Deinitializing DSock wend wrong."
END IF

DQBclose
Q& = SETMEM(200000)
PRINT
PRINT DQBerror$
END

END SUB

FUNCTION SafeToPut

JX = Player(3, REMOTE)
 SELECT CASE JX         '' From Left to right
  CASE 0 TO 8: x = 3    '' HOLE 1
  CASE 9 TO 24: x = 4   '' HOLE 2
  CASE 25 TO 40: x = 5  '' HOLE 3
  CASE 41 TO 56: x = 6  '' HOLE 4
  CASE 57 TO 72: x = 7  '' HOLE 5
  CASE 73 TO 88: x = 8  '' HOLE 6
  CASE 89 TO 96: x = 9  '' HOLE 7
 END SELECT
IF GameBoard(x, 3) = 0 THEN SafeToPut = 1

END FUNCTION

FUNCTION SendData (sHandle AS INTEGER, stMessage AS STRING)

 IF Sock(sHandle).SendBytes + LEN(stMessage) > LEN(Sock(sHandle).send) THEN
   'PRINT "[ERROR] Sendbuffer overflow. " + STR$(Sock(sHandle).SendBytes + LEN(stMessage)) + ">" + STR$(LEN(Sock(sHandle).send)) + "Cannot send message."
   'PRINT "[ERROR] " + LEFT$(stMessage, 70)
   AddMessage "[ERROR] Sendbuffer overflow!", 0
   SendData = -1
   EXIT FUNCTION
 END IF

 MID$(Sock(sHandle).send, Sock(sHandle).SendBytes + 1, LEN(stMessage)) = stMessage
 Sock(sHandle).SendBytes = Sock(sHandle).SendBytes + LEN(stMessage)

END FUNCTION

SUB SockPrepare
 
 ' Prepare New Socket, clear all Data
 Sock(0).Handle = 0
 Sock(0).State = 1
 Sock(0).OldState = 0
 Sock(0).Received = STRING$(256, CHR$(0))
 Sock(0).ReceivedBytes = 0
 Sock(0).ReceivedLine = STRING$(128, CHR$(0))
 Sock(0).send = SPACE$(256)
 Sock(0).SendBytes = 0

 ' Initialize new socket

 Sock(0).Handle = socket(2, 1, 6)
 IF Sock(0).Handle = -1 THEN
   PRINT "[ERROR] Could not reserve socket."
   EXIT SUB
 END IF

 ' Put Socket in Non Blocking mode
 IF ioctlsocket(Sock(0).Handle, FIONBIO, 1) = -1 THEN
   PRINT "[ERROR] Could not put socket in nonblocking mode."
   ' Close socket
   iRetVal = closesocket(Sock(0).Handle)
   EXIT SUB
 END IF
 
 Sock(0).State = 2

END SUB

SUB SockReceiveData (sHandle AS INTEGER)

DIM lBytesSent AS LONG

 iRetVal = recv(Sock(sHandle).Handle, MAKELONG(VARPTR(Sock(sHandle).ReceivedLine), VARSEG(Sock(sHandle).ReceivedLine)), 256, 0)

 IF iRetVal = 0 THEN
   ' Disconnected, apparently?
   iRetVal = CloseSock(sHandle)
   EXIT SUB
 END IF
 IF iRetVal < 0 THEN
   PRINT "-- Receive error:" + STR$(iRetVal)
   PRINT STR$(WSAGetLastError)
   iRetVal = CloseSock(sHandle)
   EXIT SUB
 END IF
 Sock(sHandle).ReceivedLineBytes = iRetVal

 MID$(Sock(sHandle).Received, Sock(sHandle).ReceivedBytes + 1, iRetVal) = Sock(sHandle).ReceivedLine
 Sock(sHandle).ReceivedBytes = Sock(sHandle).ReceivedBytes + iRetVal

 ProcessData sHandle

END SUB

SUB SockSendData (sHandle AS INTEGER)

DIM lBytesSent AS LONG
DIM stMessage AS STRING, iMessageLength AS INTEGER

 IF Sock(sHandle).State <> 7 THEN EXIT SUB
 IF Sock(sHandle).SendBytes = 0 THEN EXIT SUB
		     
 stMessage = LEFT$(Sock(sHandle).send, Sock(sHandle).SendBytes)
 iMessageLength = Sock(sHandle).SendBytes

 lBytesSent = send(Sock(sHandle).Handle, MAKELONG(VARPTR(Sock(sHandle).send), VARSEG(Sock(sHandle).send)), Sock(sHandle).SendBytes, 0)

 IF lBytesSent <> iMessageLength THEN
   'Print "-- Only sent out" + STR$(lBytesSent) + " of" + STR$(iMessageLength) + " bytes.",
  ELSE
 END IF
 Sock(sHandle).send = ""
 Sock(sHandle).SendBytes = 0

END SUB

